#!/bin/sh
if [ "$(id -u)" != "0" ]; then
	echo "!!! This script must be run as root !!!" 1>&2
	exit 1
fi

_olddir=`pwd`
cd $(dirname $0)
_basepath=`pwd`

_udev="/etc/udev/rules.d"
echo "Default udev-rules directory is: $_udev"
echo "Please press [ENTER] to confirm the path or enter the correct one:"
read _user
if [ "$_user" != "" ]; then
	_udev="$_user"
fi

_udevf="$_udev/99-udk-permissions.rules"
echo "Create USB permissions file"
echo "SUBSYSTEM==\"usb\", ATTRS{idVendor}==\"10f8\", ATTRS{idProduct}==\"c4??\", MODE=\"666\", ACTION==\"add\", RUN+=\"$_basepath/usb-init.sh\"" > $_udevf
echo "SUBSYSTEM==\"usb\", ATTRS{idVendor}==\"10f8\", ATTRS{idProduct}==\"c5??\", MODE=\"666\", ACTION==\"add\", RUN+=\"$_basepath/usb-init.sh\"" >> $_udevf

_uninst="$_basepath/uninstall.sh"
echo "Create uninstall script: $_uninst"
echo '#!/bin/sh' > $_uninst
echo 'if [ "$(id -u)" != "0" ]; then' >> $_uninst
echo '  echo "!!! This script must be run as root !!!" 1>&2' >> $_uninst
echo '  exit 1' >> $_uninst
echo 'fi' >> $_uninst
echo "rm -f $_udevf" >> $_uninst
echo "rm -f uninstall.sh" >> $_uninst
chmod +x $_uninst

echo "Run USB init script"
./usb-init.sh

